<template>
  <div class="bt-container">
    <el-breadcrumb style="font-size: 24px; margin-top: 16px; margin-bottom: 32px;" separator=">">
      <el-breadcrumb-item :to="{ path: '/a/teacher/NNclass/'+classId }">{{ className }}</el-breadcrumb-item>
      <el-breadcrumb-item :to="{ path: '/a/teacher/class/'+classId+'/NNjournal' }">'{{ className }}' 과목 저널링</el-breadcrumb-item>
      <el-breadcrumb-item
        v-if="$route.query.lectureId !== undefined"
        :to="{ path: '/a/teacher/class/'+classId+'/NNjournal?lectureId='+$route.query.lectureId }">'
        {{ lectureName }}' 강의 저널링
      </el-breadcrumb-item>
      <el-breadcrumb-item v-if="$route.query.itemId !== undefined">'{{ itemName }}' 아이템 저널링</el-breadcrumb-item>
    </el-breadcrumb>

    <line-chart v-if="drawGraph === true" :chartCategories="chartCategories" :chartData="chartData"/>

    <el-button v-if="firstView !== undefined" type="success" :plain='$route.query.view === "student" || $route.query.view === "keyword"' size="small" @click="onClick('CHANGE_VIEW', 'default')">
      {{ firstView }}별로 보기
    </el-button>

    <el-button type="success" :plain='$route.query.view !== "student"' size="small" @click="onClick('CHANGE_VIEW', 'student')">
      학생별로 보기
    </el-button>

    <el-button v-if="$route.query.itemId === undefined" type="success" :plain='$route.query.view !== "keyword"' size="small" @click="onClick('CHANGE_VIEW', 'keyword')">
      키워드별로 보기
    </el-button>

    <el-button type="info" size="small" @click="onClick('DRAW_GRAPH')">
      그래프 보기
    </el-button>

    <el-button type="info" size="small" @click="onClick('EXPORT_EXCEL')">
      엑셀로 내보내기
    </el-button>

    <el-table
      id="currentTable"
      :data="tableData"
      style="width: 100%">

     <el-table-column
        :label="firstColumn"
        prop="name"
        align="center">
      </el-table-column>

      <el-table-column
        v-if="secondColumn !== undefined"
        :label="secondColumn"
        :prop="secondProp"
        align="center">
      </el-table-column>

      <el-table-column
        label="이해도"
        width="150"
        prop="understanding"
        align="center">
      </el-table-column>

      <el-table-column
        label="참여도"
        width="150"
        prop="participation"
        align="center">
      </el-table-column>

      <el-table-column
        label="집중도"
        width="150"
        prop="concentration"
        align="center">
      </el-table-column>

      <el-table-column
        v-if="nextLevel !== undefined"
        label="-"
        width="140"
        align="center">
        <template slot-scope="scope">
          <el-button type="primary" size="small" @click="onClick('DETAILED_ANALYSIS', scope.row)">
            {{ nextLevel }} 분석
          </el-button>
        </template>
      </el-table-column>
    </el-table>
  </div>
</template>

<script>
import XLSX from 'xlsx';
import { saveAs } from 'file-saver';
import LineChart from '../partials/NNLineChart';
import analysisService from '../../services/analysisService';

export default {
  name: 'TeacherClassJournal',
  components: {
    LineChart,
  },
  data() {
    return {
      query: undefined,
      // level: 'class', // class(과목), lecture(강의), item(아이템)
      // view: 'default', // default, student(학생별), keyword(키워드별), keyword-student(단일 키워드 학생별)
      firstColumn: '강의', // 테이블 첫번째 컬럼 이름
      secondColumn: undefined,
      secondProp: '',
      firstView: '강의', // 첫번째 뷰 버튼에 표시할 내용
      nextLevel: '강의', // 표에서 표시할 다음단계
      className: undefined,
      lectureName: undefined,
      itemName: undefined,
      drawChart: false,
      chartCategories: [],
      chartData: [['이해도'], ['참여도'], ['집중도']],
      tableData: [],
      drawGraph: false,
    };
  },
  async created() {
    const vm = this;
    vm.query = vm.$route.query; // get 파라미터 저장
    vm.secondColumn = undefined; // 두번째 컬럼 기본값 : 표시하지 않음
    vm.drawGraph = false; // 그래프 그리기 기본값 : 그리지 않음

    const res0 = await analysisService.getBaseInfo({
      classId: vm.classId,
      lectureId: vm.$route.query.lectureId,
      itemId: vm.$route.query.itemId,
    });
    vm.className = res0.data.res.className;
    vm.lectureName = res0.data.res.lectureName;
    vm.itemName = res0.data.res.itemName;

    const res1 = await analysisService.getJournaling({
      classId: vm.classId,
      lectureId: vm.$route.query.lectureId,
      itemId: vm.$route.query.itemId,
      view: vm.$route.query.view,
    });
    if (vm.$route.query.itemId !== undefined) { // 아이템 레벨
      vm.firstView = undefined;
      switch (vm.$route.query.view) {
        case 'student': {
          vm.firstColumn = '학생 이름';
          vm.nextLevel = '학생';
          vm.secondColumn = '학생 메일';
          vm.secondProp = 'email_id';
          break;
        }
        default: {
          vm.$router.push({ path: `/a/teacher/class/${vm.classId}/NNjournal`, query: { ...vm.query, view: 'student' } });
        }
      }
    } else if (vm.$route.query.lectureId !== undefined) { // 강의 레벨
      vm.firstView = '아이템';
      switch (vm.$route.query.view) {
        case 'student': {
          vm.firstColumn = '학생 이름';
          vm.nextLevel = '학생';
          vm.secondColumn = '학생 메일';
          vm.secondProp = 'email_id';
          break;
        }
        case 'keyword': {
          vm.firstColumn = '키워드 이름';
          vm.nextLevel = '키워드-학생';
          break;
        }
        case 'keyword-student': {
          vm.nextLevel = undefined;
          break;
        }
        default: {
          vm.firstColumn = '아이템 이름';
          vm.$route.query.view = 'default';
          vm.nextLevel = '아이템';
        }
      }
    } else { // 과목 레벨
      vm.firstView = '강의';
      vm.firstColumn = '강의 이름';
      switch (vm.$route.query.view) {
        case 'student': {
          vm.firstColumn = '학생 이름';
          vm.nextLevel = '학생';
          vm.secondColumn = '학생 메일';
          vm.secondProp = 'email_id';
          break;
        }
        case 'keyword': {
          vm.firstColumn = '키워드 이름';
          vm.nextLevel = '키워드-학생';
          break;
        }
        case 'keyword-student': {
          vm.nextLevel = undefined;
          break;
        }
        default: {
          vm.firstColumn = '강의 이름';
          vm.$route.query.view = 'default';
          vm.nextLevel = '강의';
        }
      }
    }

    // 표 데이터 반영
    vm.tableData = res1.data.res;

    // 차트 데이터 양식으로 변경
    Array.prototype.push.apply(vm.chartCategories, res1.data.res.map(x => x.name));
    Array.prototype.push.apply(vm.chartData[0], res1.data.res.map(x => x.understanding));
    Array.prototype.push.apply(vm.chartData[1], res1.data.res.map(x => x.participation));
    Array.prototype.push.apply(vm.chartData[2], res1.data.res.map(x =>
      (x.concentration !== undefined ? x.concentration : 0)));
    vm.drawGraph = (vm.$route.query.drawGraph === true); // TODO: 번잡함..해소..
  },
  methods: {
    async onClick(type, payload) {
      const vm = this;
      switch (type) {
        case 'EXPORT_EXCEL': {
          let Name;
          if (vm.itemName !== undefined) {
            Name = `${vm.itemName}_아이템저널링`;
          } else if (vm.lectureName !== undefined) {
            Name = `${vm.lectureName}_강의저널링`;
          } else {
            Name = `${vm.className}_과목저널링`;
          }
          vm.exportExcel({
            fileName: Name,
            sheetName: '저널링',
          });
          break;
        }
        case 'DRAW_GRAPH': {
          vm.drawGraph = !vm.drawGraph;
          vm.$route.query.drawGraph = vm.drawGraph;
          break;
        }
        case 'CHANGE_VIEW': {
          if (payload === 'keyword') {
            vm.$notify({
              title: '알림',
              message: '키워드별 보기 : 개발중인 기능입니다.',
              type: 'warning',
              duration: 5000,
            });
            break;
          }
          vm.$router.push({ path: `/a/teacher/class/${vm.classId}/NNjournal`,
            query: {
              ...vm.query,
              view: payload,
            } });
          break;
        }
        case 'DETAILED_ANALYSIS': {
          switch (vm.nextLevel) {
            case '강의': {
              vm.$router.push({ path: `/a/teacher/class/${vm.classId}/NNjournal`,
                query: {
                  lectureId: payload.lecture_id,
                  view: vm.$route.query.view,
                  drawGraph: vm.drawGraph,
                },
              });
              break;
            }
            case '아이템': {
              vm.$router.push({ path: `/a/teacher/class/${vm.classId}/NNjournal`,
                query: {
                  lectureId: vm.$route.query.lectureId,
                  itemId: payload.lecture_item_id,
                  view: 'student',
                  drawGraph: vm.drawGraph,
                },
              });
              break;
            }
            default: {
              vm.$notify({
                title: '알림',
                message: ' 학생 분석 : 개발중인 기능입니다.',
                type: 'warning',
                duration: 5000,
              });
            }
          }
          break;
        }
        default : {
          throw new Error('unexpected type: ', type);
        }
      }
    },
    async exportExcel({ sheetName, fileName }) {
      const vm = this;
      const wb = XLSX.utils.table_to_book(document.getElementById('currentTable'), { sheet: sheetName });
      const wbout = XLSX.write(wb, { bookType: 'xlsx', bookSST: true, type: 'binary' });
      XLSX.write(wb, { bookType: 'xlsx', bookSST: true, type: 'binary' });
      saveAs(new Blob([vm.s2ab(wbout)], { type: 'application/octet-stream' }), `${fileName}.xlsx`);
    },
    s2ab(s) {
      const buf = new ArrayBuffer(s.length);
      const view = new Uint8Array(buf);
      for (let i = 0; i < s.length; i += 1) {
        view[i] = s.charCodeAt(i) && 0xFF;
      }
      return buf;
    },
  },
  computed: {
    classId() {
      return this.$route.params.classId;
    },
  },
};
</script>

<style lang="scss">
</style>
